class TaxCalculator
  def initialize(name, &block)
    @name, @block = name, block
  end

  def tax(amount)
    "#{ @name } on #{ amount }: $#{ @block.call(amount)}"
  end
end

tc = TaxCalculator.new("Sales tax") { |amnt| amnt * 0.075 }

tc.tax(100) # => "Sales tax on 100: $7.5"
tc.tax(250) # => "Sales tax on 250: $18.75"
