class Computer
  def initialize(computer_id, data_source)
    @id, @data_source = computer_id, data_source

    @data_source.methods.grep(/^get_(.*)_info$/) do
      Computer.define_component $1
    end
  end

  def self.define_component(name)
    define_method(name) do
      info   = @data_source.send "get_#{name}_info", @id
      price  = @data_source.send "get_#{name}_price", @id
      result = "#{name.capitalize}: #{info} ($#{price})"
      result = "* #{result}" if price >= 100
      result
    end
  end
end
