class Computer
  def initialize(computer_id, data_source)
    @id, @data_source = computer_id, data_source
  end

  def mouse
    component :mouse
  end
  # and so on

  private
  def component(name)
    info   = @data_source.send "get_#{name}_info", @id
    price  = @data_source.send "get_#{name}_price", @id
    result = "#{name.to_s.capitalize}: #{info} ($#{price})"
    result = "* #{result}" if price >= 100
    result
  end
end
